/* Put this script on an AI, and set "SlainMotionTags" in Design Note.
 * For example, to force a bugbeast death animation:
 *
 *    SlainMotionTags=BugDemon 0;
 *
 * Note that "Crumple 0, Die 0" are hardcoded tags that will come first in
 * the search, and your added tags may or may not have the weight to overcome
 * those.
 *
 * Refer to the motion tag lists to see available tags, and use the console
 * command `set MCoordTrace` to see in the monolog what motions are actually
 * being selected from the motiondb (`unset MCoordTrace` disables it again).
 */
class SlainMotionTags extends SqRootScript {
    function OnSlain() {
        if ("SlainMotionTags" in userparams()) {
            SetProperty("MotActorTagList", "tags", userparams()["SlainMotionTags"]);
        }
    }
}